<?php

/**
* FleetBuildingPage.php
*
* @version 1.1
* @copyright 2008 By Chlorel for XNova
*
* Modifié par Winjet
*
*/

// Page de Construction d'Elements de Flotte
// $CurrentPlanet -> Planete sur laquelle la construction est lancÃ©e
//                   Parametre passÃ© par adresse, cela permet de mettre les valeurs a jours
//                   dans le programme appelant
// $CurrentUser   -> Utilisateur qui a lancÃ© la construction
//
function FleetBuildingPage ( &$CurrentPlanet, $CurrentUser ) {
     global $lang, $resource, $phpEx, $dpath, $_POST, $CombatCaps;

    if (isset($_POST['fmenge'])) {
        // On vient de Cliquer ' Construire '
        // Et y a une liste de doléances
        $AddedInQueue                     = false;
        // Ici, on sait precisement ce qu'on aimerait bien construire ...
        foreach($_POST['fmenge'] as $Element => $Count) {
            // Construction d'Element recuperés sur la page de Flotte ...
            // ATTENTION ! La file d'attente Flotte est Commune a celle des Defenses
            // Dans fmenge, on devrait trouver un tableau des elements constructibles et du nombre d'elements souhaités

            $Element = intval($Element);
            $Count   = intval($Count);
            if ($Count > MAX_FLEET_OR_DEFS_PER_ROW) {
                $Count = MAX_FLEET_OR_DEFS_PER_ROW;
            }

            if ($Count != 0) {
                // On verifie si on a les technologies necessaires a la construction de l'element
                if ( IsTechnologieAccessible ($CurrentUser, $CurrentPlanet, $Element) ) {
                    // On verifie combien on sait faire de cet element au max
                    $MaxElements   = GetMaxConstructibleElements ( $Element, $CurrentPlanet );
                    // Si pas assez de ressources, on ajuste le nombre d'elements
                    if ($Count > $MaxElements) {
                        $Count = $MaxElements;
                    }
                    $Ressource = GetElementRessources ( $Element, $Count );
                    $BuildTime = GetBuildingTime($CurrentUser, $CurrentPlanet, $Element);
                    if ($Count >= 1) {
                        $CurrentPlanet['metal']          -= $Ressource['metal'];
                        $CurrentPlanet['crystal']        -= $Ressource['crystal'];
                        $CurrentPlanet['deuterium']      -= $Ressource['deuterium'];
                        $CurrentPlanet['neutronium']     -= $Ressource['neutronium'];
                        $CurrentPlanet['b_hangar_id']    .= "". $Element .",". $Count .";";
                    }
                }
            }
        }
    }

    // -------------------------------------------------------------------------------------------------------
    // S'il n'y a pas de Chantier ...
    if ($CurrentPlanet[$resource[21]] == 0) {
        // Veuillez avoir l'obligeance de construire le Chantier Spacial !!
        message($lang['need_hangar'], $lang['tech'][21]);
    }

    // -------------------------------------------------------------------------------------------------------
    // Construction de la page du Chantier (car si j'arrive ici ... c'est que j'ai tout ce qu'il faut pour ...
    $TabIndex = 0;
    $nb = array('0','0','0','0');
    
    // Tableau qui comportera les valeurs d'attaque limite de chaque catégorie
    $valeurs_attack_limite = array('0','201','2001','500000');
    
    // Tableaux qui comporteront le nom de chaque catégorie et les liens rapides    
    $Categorie_Name = array('Vaisseaux Faibles Puissances','Vaisseaux Moyennes Puissances',
                            'Vaisseaux Grandes Puissances','Vaisseaux Tr&egrave;s Grandes Puissances');
    $LienRapide_Name = array('Faibles Puissances','Moy. Puissances','Gran. Puissances','T. Gran. Puissances');
    
    // Tableau qui comportera la mise en forme de chaque catégorie avec les défenses
    $PageTableTemp = array();
    $nbVaisseauxCategories = array();
    
    foreach($lang['tech'] as $Element => $ElementName) {
        if ($Element > 201 && $Element <= 399) {
            if (IsTechnologieAccessible($CurrentUser, $CurrentPlanet, $Element)) {
                // Disponible à la construction

                // On regarde si on peut en acheter au moins 1
                $CanBuildOne         = IsElementBuyable($CurrentUser, $CurrentPlanet, $Element, false);
                // On regarde combien de temps il faut pour construire l'element
                $BuildOneElementTime = GetBuildingTime($CurrentUser, $CurrentPlanet, $Element);
                // Disponibilité actuelle
                $ElementCount        = $CurrentPlanet[$resource[$Element]];
                $ElementNbre         = ($ElementCount == 0) ? "" : " (".$lang['dispo'].": " . pretty_number($ElementCount) . ")";

                // En fonction de l'attaque du vaisseau, on spécifie l'index de la catégorie où il faudra rajouter le vaisseau
                if ( $CombatCaps[$Element]['attack'] >= $valeurs_attack_limite[0] && $CombatCaps[$Element]['attack'] < $valeurs_attack_limite[1] )
                    $index = 0;
                if ( $CombatCaps[$Element]['attack'] >= $valeurs_attack_limite[1] && $CombatCaps[$Element]['attack'] < $valeurs_attack_limite[2] )
                    $index = 1;
                if ( $CombatCaps[$Element]['attack'] >= $valeurs_attack_limite[2] && $CombatCaps[$Element]['attack'] < $valeurs_attack_limite[3] )
                    $index = 2;
                if ( $CombatCaps[$Element]['attack'] >= $valeurs_attack_limite[3] )
                    $index = 3;
                    
                // Vrai s'il s'agit du premier vaisseau d'une ligne
                if ($nb[$index] == 0)
                {
                    $PageTableTemp[$index] .= "\n<tr>";
                }
                
                $nbVaisseauxCategories[$index]++;
                // Construction des 3 cases de la ligne d'un element dans la page d'achat !
                // Début de ligne
                
                // Imagette + Link vers la page d'info
                $PageTableTemp[$index] .= "<th class=l width=80>";
                $PageTableTemp[$index] .= "<a href=infos.".$phpEx."?gid=".$Element.">";
                $PageTableTemp[$index] .= "<img border=0 src=\"".$dpath."gebaeude/".$Element.".gif\" align=top width=80 height=80></a>";
                $PageTableTemp[$index] .= "</th>";

                // Description
                $PageTableTemp[$index] .= "<td class=l width = 320>";
                $PageTableTemp[$index] .= "<a href=infos.".$phpEx."?gid=".$Element.">".$ElementName."</a> ".$ElementNbre."<br>";
                $PageTableTemp[$index] .= "".$lang['res']['descriptions'][$Element]."<br><br>";
                // On affiche le 'prix' avec eventuellement ce qui manque en ressource
                $PageTableTemp[$index] .= GetElementPrice($CurrentUser, $CurrentPlanet, $Element, false);
                // On affiche le temps de construction (c'est toujours tellement plus joli)
                $PageTableTemp[$index] .= ShowBuildTime($BuildOneElementTime);
                $PageTableTemp[$index] .= "</td>";

                // Case nombre d'elements a construire
                $PageTableTemp[$index] .= "<th class=l width=50>";
                // Si ... Et Seulement si je peux construire je mets la p'tite zone de saisie
                if ($CanBuildOne) {
                    $TabIndex++;
                    $PageTableTemp[$index] .= "<input type=text name=fmenge[".$Element."] alt='".$lang['tech'][$Element]."' size=5 maxlength=5 value=0 tabindex=".$TabIndex.">";
                    $maxElement = GetMaxConstructibleElements($Element, $CurrentPlanet);
                    if ($maxElement > MAX_FLEET_OR_DEFS_PER_ROW) $maxElement = MAX_FLEET_OR_DEFS_PER_ROW;
                    $PageTableTemp[$index] .= "<br><br><input type=\"button\" value=\"Max\" onclick=\"document.getElementsByName('fmenge[".$Element."]')[0].value = '$maxElement';\">";
                }
                $PageTableTemp[$index] .= "</th></center>";

                // Fin de ligne (les 3 cases sont construites !!
                
                // Vrai si c'est le deuxième vaisseau qui a été ajouté
                if ($nb[$index] != 0)
                {
                    // On rajoute </tr> pour aller à la ligne
                    $PageTableTemp[$index] .= "</tr>";
                    // On remet à 0 pour dire que le prochain vaisseau ajouté sera le premier d'une ligne
                    $nb[$index] = 0;
                }
                else
                {
                    // Si on est toujours sur le premier vaisseau, on incrémente de 1 pour indiquer qu'on passe au 2° vaisseau
                    $nb[$index]++;
                }
            }
        }
    }

    if ($CurrentPlanet['b_hangar_id'] != '') {
        $BuildQueue .= ElementBuildListBox( $CurrentUser, $CurrentPlanet );
    }

    $PageTable = "";
    
    for( $i = 0; $i <= 3; $i++)
    {
        // Vu qu'on affiche 2 vaisseaux par ligne, il est possible que le nombre de vaisseaux dans une catégorie soit impair
        // Dans ce cas, l'entête de la prochaine catégorie se trouvera sur la même ligne que le dernier vaisseau de la catégorie précédente
        // Il faut donc tester si les 4 derniers caractères de $PageTableTemp[$i] sont </tr>
        // Si c'est le cas, la catégorie précédente possède à la fin 2 vaisseaux sur la dernière  ligne, aucun soucis, il y a rien à faire ^^
        // Si c'est pas le cas, la catégorie précédente ne possède qu'un vaisseau sur la dernière ligne, il faut donc rajouter </tr> pour aller à la ligne
        if (substr($PageTableTemp[$i], strlen($PageTableTemp[$i]) - 4, 4) != "</tr>")
            $PageTableTemp[$i] .= "</tr>";
        
        // On réunit toutes les catégories dans une seule variable
        // On affiche la catégorie seulement si elle contient un vaisseau
        if ($nbVaisseauxCategories[$i] <> 0)
        {
            // Si la catégorie actuelle ne comporte qu'un seul vaisseau
            if ($nbVaisseauxCategories[$i] == 1)
            {
                // Mise en forme spéciale
                $PageCategorie[$i] = "<td width=80 class=c id=".$i." colspan=2 align=center><h2><br><font color=Red>".$Categorie_Name[$i]."</font></h2></td><th class=k align=center><a href=#0>".$LienRapide_Name[0]."</a><br><a href=#1>".$LienRapide_Name[1]."</a><br><a href=#2>".$LienRapide_Name[2]."</a><br><a href=#3>".$LienRapide_Name[3]."</a></th>";
            }
            else
            {
                // Sinon
                // Mise en forme classique
                $PageCategorie[$i] = "<td class=c id=".$i." colspan=2 align=center><h2><br><font color=Red>".$Categorie_Name[$i]."</font></h2></td><th class=k>Nombres &agrave construire</th>";
                $PageCategorie[$i] .= "<td class=c colspan=2 align=center><a href=#0>".$LienRapide_Name[0]."</a><br><a href=#1>".$LienRapide_Name[1]."</a><br><a href=#2>".$LienRapide_Name[2]."</a><br><a href=#3>".$LienRapide_Name[3]."</a>";
                $PageCategorie[$i] .= "<th class=k>Nombres &agrave construire</th>";
            }
            
            $PageCategorie[$i] .= $PageTableTemp[$i];
            $PageTable .= $PageCategorie[$i];
        }
    }
    
    $parse = $lang;
    // La page se trouve dans $PageTable;
    $parse['buildlist']    = $PageTable;
    // Et la liste de constructions en cours dans $BuildQueue;
    $parse['buildinglist'] = $BuildQueue;
    $page .= parsetemplate(gettemplate('buildings_fleet'), $parse);

    display($page, $lang['Fleet']);
}
// Version History
// - 1.0 Modularisation
// - 1.1 Correction mise en place d'une limite max d'elements constructibles par ligne
// - 1.2 Mise en place de catégories en fonction de la puissance des vaisseaux (Winjet)
// - 1.3 Affichage de 2 vaisseaux par ligne pour réduire la hauteur de la page (Winjet)
// - 1.4 Affichage des catégories seulement si un vaisseau s'y trouve (Winjet)
// - 1.5 Mise en forme spéciale des catégories si elles contiennent seulement un vaisseau  (Winjet)
//
?>